﻿using Dapper;
using DapperStart.Models;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Options;
using System.Data.SqlClient;

namespace DapperStart.Controllers
{
    public class RelationController : Controller
    {
        private IOptions<Connections> cs;

        public RelationController(IOptions<Connections> cs)
        {
            this.cs = cs;
        }

        public IActionResult ReadOneOne()
        {
            string myCS = cs.Value.DefaultConnection;

            string sql = "SELECT * FROM Invoice AS A INNER JOIN InvoiceDetail AS B ON A.Id = B.InvoiceId;";

            using (var connection = new SqlConnection(myCS))
            {

                var invoices = connection.Query<Invoice, InvoiceDetail, Invoice>(
                        sql,
                        (invoice, invoiceDetail) =>
                        {
                            invoice.InvoiceDetail = invoiceDetail;
                            return invoice;
                        },
                        splitOn: "InvoiceId")
                    .Distinct()
                    .ToList();
            }

            return RedirectToAction("Index", "Home");
        }

        public IActionResult ReadOneMany()
        {
            string myCS = cs.Value.DefaultConnection;

            string sql = "SELECT * FROM Employee AS A INNER JOIN Address AS B ON A.Id = B.EmployeeID;";

            using (var connection = new SqlConnection(myCS))
            {
                var dictionary = new Dictionary<int, Employee>();


                var list = connection.Query<Employee, Address, Employee>(
                sql,
                (employee, address) =>
                {
                    Employee e;

                    if (!dictionary.TryGetValue(employee.Id, out e))
                    {
                        e = employee;
                        e.Address = new List<Address>();
                        dictionary.Add(e.Id, e);
                    }

                    e.Address.Add(address);
                    return e;
                },
                splitOn: "Id")
                .Distinct()
                .ToList();
            }

            return RedirectToAction("Index", "Home");
        }
    }
}
