﻿using Dapper;
using DapperStart.Models;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;
using Microsoft.Extensions.Options;
using System.Data;
using System.Data.SqlClient;

namespace DapperStart.Controllers
{
    public class SchoolDetailController : Controller
    {
        private IOptions<Connections> cs;

        public SchoolDetailController(IOptions<Connections> cs)
        {
            this.cs = cs;
        }

        public IActionResult Read()
        {
            return View();
        }

        public IActionResult CreateUpdate(int id)
        {
            string myCS = cs.Value.DefaultConnection;
            string query = "SELECT * FROM SchoolDetail Where SchoolId=@SchoolId";

            var sd = new SchoolDetail();
            using (var connection = new SqlConnection(myCS))
            {
                sd = connection.Query<SchoolDetail>(query, new { SchoolId = id }).FirstOrDefault();
            }

            return View(sd);
        }

        [HttpPost]
        public IActionResult CreateUpdate(SchoolDetail schoolDetail, int id)
        {
            if (ModelState.IsValid)
            {
                string myCS = cs.Value.DefaultConnection;

                using (var connection = new SqlConnection(myCS))
                {
                    var rowsAffected = connection.Execute("CreateUpdateSchoolDetail", new { SchoolId = id, PrincipalName = schoolDetail.PrincipalName, EstablishYear = schoolDetail.EstablishYear, Address = schoolDetail.Address, Level = schoolDetail.Level, Telephone = schoolDetail.Telephone, TotalStudent = schoolDetail.TotalStudent }, commandType: CommandType.StoredProcedure);
                }

                return RedirectToAction("ReadSSD", "School");
            }
            else
                return View();
        }

        [HttpPost]
        public IActionResult Delete(int id)
        {
            string myCS = cs.Value.DefaultConnection;

            var sql = @"Delete From SchoolDetail Where SchoolId = @Id";

            using (var connection = new SqlConnection(myCS))
            {
                var result = connection.Execute(sql, new { Id = id });
            }

            return RedirectToAction("ReadSSD", "School");
        }

    }
}
