﻿using Dapper;
using DapperStart.Models;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;
using Microsoft.Extensions.Options;
using System.Data.SqlClient;

namespace DapperStart.Controllers
{
    public class TeacherController : Controller
    {
        private IOptions<Connections> cs;

        public TeacherController(IOptions<Connections> cs)
        {
            this.cs = cs;
        }

        public IActionResult Read()
        {
            return View();
        }

        public IActionResult Create()
        {
            return View();
        }

        [HttpPost]
        public IActionResult Create(Teacher teacher, int id)
        {
            if (ModelState.IsValid)
            {
                string myCS = cs.Value.DefaultConnection;

                var sql = @"Insert into Teacher(SchoolId, Name, Address, Qualification, Salary) values (@SchoolId, @Name, @Address, @Qualification, @Salary)";

                using (var connection = new SqlConnection(myCS))
                {
                    var rowsAffected = connection.Execute(sql, new { SchoolId = id, Name = teacher.Name, Address = teacher.Address, Qualification = teacher.Qualification, Salary = teacher.Salary });
                }

                return RedirectToAction("ReadST", "School");
            }
            else
                return View();
        }

        public IActionResult Update(int id)
        {
            string myCS = cs.Value.DefaultConnection;
            string query = "SELECT * FROM Teacher Where Id=@Id";

            var teacher = new Teacher();
            using (var connection = new SqlConnection(myCS))
            {
                teacher = connection.Query<Teacher>(query, new { Id = id }).FirstOrDefault();
            }

            return View(teacher);
        }

        [HttpPost]
        public IActionResult Update(Teacher teacher, int id)
        {
            if (ModelState.IsValid)
            {
                string myCS = cs.Value.DefaultConnection;

                var sql = @"Update Teacher SET Name=@Name, Address=@Address, Qualification=@Qualification, Salary=@Salary WHERE Id=@Id";

                using (var connection = new SqlConnection(myCS))
                {
                    var rowsAffected = connection.Execute(sql, new { Name = teacher.Name, Address = teacher.Address, Qualification = teacher.Qualification, Salary = teacher.Salary, Id = id });
                }

                return RedirectToAction("ReadST", "School");
            }
            else
                return View();
        }

        [HttpPost]
        public IActionResult Delete(int id)
        {
            string myCS = cs.Value.DefaultConnection;

            var sql = @"Delete From Teacher Where Id = @Id";

            using (var connection = new SqlConnection(myCS))
            {
                var result = connection.Execute(sql, new { Id = id });
            }

            return RedirectToAction("ReadST", "School");
        }
    }
}
